/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * e:/builds/moz2_slave/xulrunner_win32_build/build/xpcom/threads/nsIProcess.idl
 */

package org.mozilla.interfaces;

public interface nsIProcess extends nsISupports {

  String NS_IPROCESS_IID =
    "{d573f1f3-fcdd-4dbe-980b-4ba79e6718dc}";

  /**
   * Initialises the process with an executable to be run. Call the run method
   * to run the executable.
   * @param executable The executable to run.
   */
  void init(nsIFile executable);

  /**
   * Not implemented. Will be removed in a future version of this interface.
   */
  void initWithPid(long pid);

  /**
   * Kills the running process. After exiting the process will either have
   * been killed or a failure will have been returned.
   */
  void kill();

  /**
   * Executes the file this object was initialized with
   * @param blocking   Whether to wait until the process terminates before
                       returning or not.
   * @param args       An array of arguments to pass to the process in the
   *                   native character set.
   * @param count      The length of the args array.
   */
  void run(boolean blocking, String[] args, long count);

  /**
   * Not implemented. Will be removed in a future version of this interface.
   */
  nsIFile getLocation();

  /**
   * The process identifier of the currently running process. This will only
   * be available after the process has started and may not be available on
   * some platforms.
   */
  long getPid();

  /**
   * Not implemented. Will be removed in a future version of this interface.
   */
  String getProcessName();

  /**
   * Not implemented. Will be removed in a future version of this interface.
   */
  long getProcessSignature();

  /**
   * The exit value of the process. This is only valid after the process has
   * exited.
   */
  int getExitValue();

  /**
   * Returns whether the process is currently running or not.
   */
  boolean getIsRunning();

}